from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="PkgRoutesMagicSearchRequest")


@_attrs_define
class PkgRoutesMagicSearchRequest:
    """
    Attributes:
        c (str | Unset):
        q (str | Unset):
        sc (bool | Unset):
        t (str | Unset):
    """

    c: str | Unset = UNSET
    q: str | Unset = UNSET
    sc: bool | Unset = UNSET
    t: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        c = self.c

        q = self.q

        sc = self.sc

        t = self.t

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if c is not UNSET:
            field_dict["c"] = c
        if q is not UNSET:
            field_dict["q"] = q
        if sc is not UNSET:
            field_dict["sc"] = sc
        if t is not UNSET:
            field_dict["t"] = t

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        c = d.pop("c", UNSET)

        q = d.pop("q", UNSET)

        sc = d.pop("sc", UNSET)

        t = d.pop("t", UNSET)

        pkg_routes_magic_search_request = cls(
            c=c,
            q=q,
            sc=sc,
            t=t,
        )

        pkg_routes_magic_search_request.additional_properties = d
        return pkg_routes_magic_search_request

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
